import { DragEvent, ReactNode } from "react";
import "./KanbanBoard.css";
export interface Card {
    id: string;
    title: string;
    status: string;
    avatarPath?: string;
}
export interface Column {
    title: string;
    key: string;
    color: string;
}
interface KanbanBoardProps {
    columns: Column[];
    initialCards: Card[];
    columnForAddCard: string;
    onCardMove?: (cardId: string, newStatus: string) => void;
    onCardEdit?: (cardId: string, newTitle: string) => void;
    onCardDelete?: (cardId: string) => void;
    onTaskAddedCallback?: (title: string) => void;
    renderCard?: (card: Card, handleDragStart: (e: DragEvent<HTMLDivElement>, card: Card) => void) => ReactNode;
    renderAvatar?: (avatarPath?: string) => ReactNode;
    renderAddCard?: (column: string, setCards: React.Dispatch<React.SetStateAction<Card[]>>) => ReactNode;
}
declare const KanbanBoard: ({ columns, columnForAddCard, initialCards, onCardMove, onCardEdit, onCardDelete, onTaskAddedCallback, renderCard, renderAvatar, renderAddCard, }: KanbanBoardProps) => import("react/jsx-runtime").JSX.Element;
export default KanbanBoard;
