"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var framer_motion_1 = require("framer-motion");
require("./KanbanBoard.css");
var DeleteIcon = function () {
    return ((0, jsx_runtime_1.jsxs)("svg", { width: "23", height: "23", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", children: [(0, jsx_runtime_1.jsx)("path", { d: "M10 11V17", stroke: "#F11D42", strokeWidth: "2", strokeLinecap: "round", strokeLinejoin: "round" }), (0, jsx_runtime_1.jsx)("path", { d: "M14 11V17", stroke: "#F11D42", strokeWidth: "2", strokeLinecap: "round", strokeLinejoin: "round" }), (0, jsx_runtime_1.jsx)("path", { d: "M4 7H20", stroke: "#F11D42", strokeWidth: "2", strokeLinecap: "round", strokeLinejoin: "round" }), (0, jsx_runtime_1.jsx)("path", { d: "M6 7H12H18V18C18 19.6569 16.6569 21 15 21H9C7.34315 21 6 19.6569 6 18V7Z", stroke: "#F11D42", strokeWidth: "2", strokeLinecap: "round", strokeLinejoin: "round" }), (0, jsx_runtime_1.jsx)("path", { d: "M9 5C9 3.89543 9.89543 3 11 3H13C14.1046 3 15 3.89543 15 5V7H9V5Z", stroke: "#F11D42", strokeWidth: "2", strokeLinecap: "round", strokeLinejoin: "round" })] }));
};
var EditIcon = function () {
    return ((0, jsx_runtime_1.jsxs)("svg", { width: "20", height: "20", viewBox: "0 0 24 24", fill: "none", xmlns: "http://www.w3.org/2000/svg", children: [(0, jsx_runtime_1.jsx)("path", { d: "M21.2799 6.40005L11.7399 15.94C10.7899 16.89 7.96987 17.33 7.33987 16.7C6.70987 16.07 7.13987 13.25 8.08987 12.3L17.6399 2.75002C17.8754 2.49308 18.1605 2.28654 18.4781 2.14284C18.7956 1.99914 19.139 1.92124 19.4875 1.9139C19.8359 1.90657 20.1823 1.96991 20.5056 2.10012C20.8289 2.23033 21.1225 2.42473 21.3686 2.67153C21.6147 2.91833 21.8083 3.21243 21.9376 3.53609C22.0669 3.85976 22.1294 4.20626 22.1211 4.55471C22.1128 4.90316 22.0339 5.24635 21.8894 5.5635C21.7448 5.88065 21.5375 6.16524 21.2799 6.40005V6.40005Z", stroke: "#000000", strokeWidth: "1.5", strokeLinecap: "round", strokeLinejoin: "round" }), (0, jsx_runtime_1.jsx)("path", { d: "M11 4H6C4.93913 4 3.92178 4.42142 3.17163 5.17157C2.42149 5.92172 2 6.93913 2 8V18C2 19.0609 2.42149 20.0783 3.17163 20.8284C3.92178 21.5786 4.93913 22 6 22H17C19.21 22 20 20.2 20 18V13", stroke: "#000000", strokeWidth: "1.5", strokeLinecap: "round", strokeLinejoin: "round" })] }));
};
var KanbanBoard = function (_a) {
    var columns = _a.columns, columnForAddCard = _a.columnForAddCard, initialCards = _a.initialCards, onCardMove = _a.onCardMove, onCardEdit = _a.onCardEdit, onCardDelete = _a.onCardDelete, onTaskAddedCallback = _a.onTaskAddedCallback, renderCard = _a.renderCard, renderAvatar = _a.renderAvatar, renderAddCard = _a.renderAddCard;
    var _b = (0, react_1.useState)(initialCards), cards = _b[0], setCards = _b[1];
    (0, react_1.useEffect)(function () {
        setCards(initialCards);
    }, [initialCards]);
    return ((0, jsx_runtime_1.jsx)("div", { className: "kanban-board", children: columns.map(function (column) { return ((0, jsx_runtime_1.jsx)(ColumnComponent, { title: column.title, column: column.key, cards: cards, setCards: setCards, color: column.color, onCardMove: onCardMove, onCardEdit: onCardEdit, onCardDelete: onCardDelete, renderCard: renderCard, renderAvatar: renderAvatar, renderAddCard: renderAddCard, onTaskAddedCallback: onTaskAddedCallback, columnForAddCard: columnForAddCard }, column.key)); }) }));
};
var ColumnComponent = function (_a) {
    var title = _a.title, column = _a.column, cards = _a.cards, setCards = _a.setCards, columnForAddCard = _a.columnForAddCard, color = _a.color, onCardMove = _a.onCardMove, onCardEdit = _a.onCardEdit, onCardDelete = _a.onCardDelete, renderCard = _a.renderCard, renderAvatar = _a.renderAvatar, renderAddCard = _a.renderAddCard, onTaskAddedCallback = _a.onTaskAddedCallback;
    var filteredCards = cards.filter(function (card) { return card.status === column; });
    var _b = (0, react_1.useState)(false), active = _b[0], setActive = _b[1];
    var _c = (0, react_1.useState)(null), editingCardId = _c[0], setEditingCardId = _c[1];
    var _d = (0, react_1.useState)(""), newTitle = _d[0], setNewTitle = _d[1];
    var handleDragStart = function (e, card) {
        e.dataTransfer.setData("cardId", card.id);
    };
    var handleDragEnd = function (e) {
        var cardId = e.dataTransfer.getData("cardId");
        setActive(false);
        clearHighlights();
        var indicators = getIndicators();
        var element = getNearestIndicator(e, indicators).element;
        var before = element.dataset.before || "-1";
        if (before !== cardId) {
            var copy = __spreadArray([], cards, true);
            var cardToTransfer = copy.find(function (c) { return c.id === cardId; });
            if (!cardToTransfer)
                return;
            cardToTransfer = __assign(__assign({}, cardToTransfer), { status: column });
            copy = copy.filter(function (c) { return c.id !== cardId; });
            var moveToBack = before === "-1";
            if (moveToBack) {
                copy.push(cardToTransfer);
            }
            else {
                var insertAtIndex = copy.findIndex(function (el) { return el.id === before; });
                if (insertAtIndex === undefined)
                    return;
                copy.splice(insertAtIndex, 0, cardToTransfer);
            }
            setCards(copy);
            onCardMove === null || onCardMove === void 0 ? void 0 : onCardMove(cardId, column);
        }
    };
    var handleDragOver = function (e) {
        e.preventDefault();
        highlightIndicator(e);
        setActive(true);
    };
    var clearHighlights = function (els) {
        var indicators = els || getIndicators();
        indicators.forEach(function (i) {
            i.style.opacity = "0";
        });
    };
    var highlightIndicator = function (e) {
        var indicators = getIndicators();
        clearHighlights(indicators);
        var el = getNearestIndicator(e, indicators);
        el.element.style.opacity = "1";
    };
    var getNearestIndicator = function (e, indicators) {
        var DISTANCE_OFFSET = 50;
        var el = indicators.reduce(function (closest, child) {
            var box = child.getBoundingClientRect();
            var offset = e.clientY - (box.top + DISTANCE_OFFSET);
            if (offset < 0 && offset > closest.offset) {
                return { offset: offset, element: child };
            }
            else {
                return closest;
            }
        }, {
            offset: Number.NEGATIVE_INFINITY,
            element: indicators[indicators.length - 1],
        });
        return el;
    };
    var handleDragLeave = function () {
        clearHighlights();
        setActive(false);
    };
    var getIndicators = function () {
        return Array.from(document.querySelectorAll("[data-column=\"".concat(column, "\"]")));
    };
    var handleDeleteCard = function (cardId) {
        if (onCardDelete)
            onCardDelete(cardId);
        setCards(function (prevCards) { return prevCards.filter(function (card) { return card.id !== cardId; }); });
    };
    var handleEditClick = function (cardId, currentTitle) {
        setEditingCardId(cardId);
        setNewTitle(currentTitle);
    };
    var handleSaveEdit = function (cardId) {
        if (onCardEdit)
            onCardEdit(cardId, newTitle);
        setCards(function (prevCards) {
            return prevCards.map(function (card) {
                return card.id === cardId ? __assign(__assign({}, card), { title: newTitle }) : card;
            });
        });
        setEditingCardId(null);
    };
    var handleEditChange = function (e) {
        setNewTitle(e.target.value);
    };
    return ((0, jsx_runtime_1.jsxs)("div", { className: "kanban-column ".concat(active ? "active" : ""), onDrop: handleDragEnd, onDragOver: handleDragOver, onDragLeave: handleDragLeave, children: [(0, jsx_runtime_1.jsxs)("div", { className: "column-title", style: { backgroundColor: color }, children: [title, " ", (0, jsx_runtime_1.jsx)("span", { className: "counter", children: filteredCards.length })] }), (0, jsx_runtime_1.jsxs)("div", { className: "column-content ".concat(active ? "active" : ""), children: [filteredCards.map(function (card) { return ((0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsx)(DropIndicator, { beforeId: card.id, column: column }), editingCardId === card.id ? ((0, jsx_runtime_1.jsx)("div", { className: "card-edit", children: (0, jsx_runtime_1.jsx)("input", { autoFocus: true, type: "text", value: newTitle, onChange: handleEditChange, onBlur: function () { return handleSaveEdit(card.id); } }) })) : renderCard ? ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [renderCard(card, handleDragStart), (0, jsx_runtime_1.jsxs)("div", { className: "card-actions", children: [(0, jsx_runtime_1.jsx)("div", { onClick: function () { return handleEditClick(card.id, card.title); }, children: (0, jsx_runtime_1.jsx)(EditIcon, {}) }), (0, jsx_runtime_1.jsx)("div", { onClick: function () { return handleDeleteCard(card.id); }, children: (0, jsx_runtime_1.jsx)(DeleteIcon, {}) })] })] })) : ((0, jsx_runtime_1.jsxs)(DefaultCard, __assign({}, card, { handleDragStart: handleDragStart, renderAvatar: renderAvatar, children: [" ", (0, jsx_runtime_1.jsxs)("div", { className: "card-actions", children: [(0, jsx_runtime_1.jsx)("div", { onClick: function () { return handleEditClick(card.id, card.title); }, children: (0, jsx_runtime_1.jsx)(EditIcon, {}) }), (0, jsx_runtime_1.jsx)("div", { onClick: function () { return handleDeleteCard(card.id); }, children: (0, jsx_runtime_1.jsx)(DeleteIcon, {}) })] })] })))] }, card.id)); }), (0, jsx_runtime_1.jsx)(DropIndicator, { beforeId: -1, column: column }), columnForAddCard === column ? (renderAddCard ? (renderAddCard(column, setCards)) : ((0, jsx_runtime_1.jsx)(DefaultAddCard, { column: column, setCards: setCards, onTaskAddedCallback: onTaskAddedCallback }))) : null] })] }));
};
var DefaultCard = function (_a) {
    var title = _a.title, avatarPath = _a.avatarPath, id = _a.id, status = _a.status, handleDragStart = _a.handleDragStart, renderAvatar = _a.renderAvatar, children = _a.children;
    return ((0, jsx_runtime_1.jsxs)(framer_motion_1.motion.div, { layout: true, layoutId: id, draggable: "true", onDragStart: function (e) { return handleDragStart(e, { title: title, id: id, status: status }); }, className: "card", children: [(0, jsx_runtime_1.jsxs)("div", { className: "card-info", children: [(0, jsx_runtime_1.jsx)("p", { children: title }), renderAvatar ? (renderAvatar(avatarPath)) : ((0, jsx_runtime_1.jsx)(DefaultAvatar, { avatarPath: avatarPath }))] }), children] }));
};
var DefaultAvatar = function (_a) {
    var avatarPath = _a.avatarPath;
    if (!avatarPath)
        return null;
    return ((0, jsx_runtime_1.jsx)("img", { src: avatarPath, alt: "img ".concat(avatarPath), className: "avatar", style: { borderRadius: "50%", width: "40px", height: "40px" } }));
};
var DefaultAddCard = function (_a) {
    var column = _a.column, setCards = _a.setCards, onTaskAddedCallback = _a.onTaskAddedCallback;
    var _b = (0, react_1.useState)(false), adding = _b[0], setAdding = _b[1];
    var _c = (0, react_1.useState)(""), title = _c[0], setTitle = _c[1];
    var handleAddCard = function (e) {
        e.preventDefault();
        setCards(function (prev) { return __spreadArray(__spreadArray([], prev, true), [
            {
                id: Math.random().toString(),
                title: title,
                status: column,
            },
        ], false); });
        if (onTaskAddedCallback)
            onTaskAddedCallback(title);
        setTitle("");
        setAdding(false);
    };
    return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: adding ? ((0, jsx_runtime_1.jsxs)(framer_motion_1.motion.form, { layout: true, onSubmit: handleAddCard, className: "add-card-form", children: [(0, jsx_runtime_1.jsx)("textarea", { rows: 3, autoFocus: true, value: title, onChange: function (e) { return setTitle(e.target.value); }, placeholder: "Add a card..." }), (0, jsx_runtime_1.jsxs)("div", { className: "add-card-actions", children: [(0, jsx_runtime_1.jsx)("span", { className: "close-btn", onClick: function () { return setAdding(false); }, children: "Close" }), (0, jsx_runtime_1.jsx)("button", { className: "submit-btn", type: "submit", children: "+ Add" })] })] })) : ((0, jsx_runtime_1.jsx)(framer_motion_1.motion.button, { layout: true, onClick: function () { return setAdding(true); }, className: "add-card", children: (0, jsx_runtime_1.jsx)("span", { children: "Add card +" }) })) }));
};
var DropIndicator = function (_a) {
    var beforeId = _a.beforeId, column = _a.column;
    return ((0, jsx_runtime_1.jsx)("div", { "data-before": beforeId, "data-column": column, className: "drop-indicator" }));
};
exports.default = KanbanBoard;
